javax.lang.model.util

## Class SimpleTypeVisitor6<R,P>

- java.lang.Object
- - javax.lang.model.util.AbstractTypeVisitor6<R,P>
  - - javax.lang.model.util.SimpleTypeVisitor6<R,P>

- Type Parameters:
    `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
    `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.
  All Implemented Interfaces:
    TypeVisitor<R,P>
  Direct Known Subclasses:
    TypeKindVisitor6

      @SupportedSourceVersion(value=RELEASE_6)
      public class SimpleTypeVisitor6<R,P>
      extends AbstractTypeVisitor6<R,P>

  A simple visitor of types with default behavior appropriate for the `RELEASE_6` source version. Visit methods corresponding to `RELEASE_6` language constructs call `defaultAction(javax.lang.model.type.TypeMirror, P)`, passing their arguments to `defaultAction`'s corresponding parameters.

  Methods in this class may be overridden subject to their general contract. Note that annotating methods in concrete subclasses with `@Override` will help ensure that methods are overridden as intended.

  WARNING: The `TypeVisitor` interface implemented by this class may have methods added to it in the future to accommodate new, currently unknown, language structures added to future versions of the Java™ programming language. Therefore, methods whose names begin with `"visit"` may be added to this class in the future; to avoid incompatibilities, classes which extend this class should not declare any instance methods with names beginning with `"visit"`.

  When such a new visit method is added, the default implementation in this class will be to call the `visitUnknown` method. A new simple type visitor class will also be introduced to correspond to the new language level; this visitor will have different default behavior for the visit method in question. When the new visitor is introduced, all or portions of this visitor may be deprecated.

  Since:
    1.6

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected R` | `DEFAULT_VALUE` Default value to be returned; `defaultAction` returns this value unless the method is overridden.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SimpleTypeVisitor6()` Constructor for concrete subclasses; uses `null` for the default value.
    `protected` | `SimpleTypeVisitor6(R defaultValue)` Constructor for concrete subclasses; uses the argument for the default value.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected R` | `defaultAction(TypeMirror e, P p)` The default action for visit methods.
    `R` | `visitArray(ArrayType t, P p)` Visits an array type.
    `R` | `visitDeclared(DeclaredType t, P p)` Visits a declared type.
    `R` | `visitError(ErrorType t, P p)` Visits an error type.
    `R` | `visitExecutable(ExecutableType t, P p)` Visits an executable type.
    `R` | `visitNoType(NoType t, P p)` Visits a `NoType` instance.
    `R` | `visitNull(NullType t, P p)` Visits the null type.
    `R` | `visitPrimitive(PrimitiveType t, P p)` Visits a primitive type.
    `R` | `visitTypeVariable(TypeVariable t, P p)` Visits a type variable.
    `R` | `visitWildcard(WildcardType t, P p)` Visits a wildcard type.

    - ### Methods inherited from class javax.lang.model.util.AbstractTypeVisitor6

      `visit, visit, visitUnknown`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_VALUE

          protected final R DEFAULT_VALUE

      Default value to be returned; `defaultAction` returns this value unless the method is overridden.

  - ### Constructor Detail

    - #### SimpleTypeVisitor6

          protected SimpleTypeVisitor6()

      Constructor for concrete subclasses; uses `null` for the default value.

    - #### SimpleTypeVisitor6

          protected SimpleTypeVisitor6(R defaultValue)

      Constructor for concrete subclasses; uses the argument for the default value.
      Parameters:
        `defaultValue` - the value to assign to `DEFAULT_VALUE`

  - ### Method Detail

    - #### defaultAction

          protected R defaultAction(TypeMirror e,
                        P p)

      The default action for visit methods. The implementation in this class just returns `DEFAULT_VALUE`; subclasses will commonly override this method.

    - #### visitPrimitive

          public R visitPrimitive(PrimitiveType t,
                         P p)

      Visits a primitive type. This implementation calls `defaultAction`.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitNull

          public R visitNull(NullType t,
                    P p)

      Visits the null type. This implementation calls `defaultAction`.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitArray

          public R visitArray(ArrayType t,
                     P p)

      Visits an array type. This implementation calls `defaultAction`.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitDeclared

          public R visitDeclared(DeclaredType t,
                        P p)

      Visits a declared type. This implementation calls `defaultAction`.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitError

          public R visitError(ErrorType t,
                     P p)

      Visits an error type. This implementation calls `defaultAction`.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitTypeVariable

          public R visitTypeVariable(TypeVariable t,
                            P p)

      Visits a type variable. This implementation calls `defaultAction`.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitWildcard

          public R visitWildcard(WildcardType t,
                        P p)

      Visits a wildcard type. This implementation calls `defaultAction`.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitExecutable

          public R visitExecutable(ExecutableType t,
                          P p)

      Visits an executable type. This implementation calls `defaultAction`.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitNoType

          public R visitNoType(NoType t,
                      P p)

      Visits a `NoType` instance. This implementation calls `defaultAction`.
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright © 1993, 2014, Oracle and/or its affiliates. All rights reserved.